'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDisplayName(WrappedComponent) {
    return 'Geolocated(' + (WrappedComponent.displayName || WrappedComponent.name || 'Component') + ')';
}

var geolocated = function geolocated(config) {
    return function (WrappedComponent) {
        var defaultConfig = {
            positionOptions: {
                enableHighAccuracy: true,
                maximumAge: 0,
                timeout: Infinity
            }
        };
        var activeConfig = (0, _lodash2.default)({}, defaultConfig, config);

        var result = function (_React$Component) {
            _inherits(Geolocated, _React$Component);

            function Geolocated(props) {
                _classCallCheck(this, Geolocated);

                var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Geolocated).call(this, props));

                _this.state = {
                    coords: null,
                    isGeolocationEnabled: false,
                    isGeolocationAvailable: Boolean(navigator && navigator.geolocation),
                    isGettingPosition: true,
                    positionError: null
                };

                _this.onPositionError = _this.onPositionError.bind(_this);
                _this.onPositionSuccess = _this.onPositionSuccess.bind(_this);
                return _this;
            }

            _createClass(Geolocated, [{
                key: 'onPositionError',
                value: function onPositionError(positionError) {
                    this.setState((0, _lodash2.default)({}, this.state, {
                        coords: null,
                        isGeolocationEnabled: false,
                        isGettingPosition: false,
                        positionError: positionError
                    }));
                }
            }, {
                key: 'onPositionSuccess',
                value: function onPositionSuccess(position) {
                    this.setState((0, _lodash2.default)({}, this.state, {
                        coords: position.coords,
                        isGeolocationEnabled: true,
                        isGettingPosition: false,
                        positionError: null
                    }));
                }
            }, {
                key: 'componentDidMount',
                value: function componentDidMount() {
                    navigator.geolocation.getCurrentPosition(this.onPositionSuccess, this.onPositionError, activeConfig.positionOptions);
                }
            }, {
                key: 'render',
                value: function render() {
                    return _react2.default.createElement(WrappedComponent, this.state);
                }
            }]);

            return Geolocated;
        }(_react2.default.Component);
        result.displayName = getDisplayName(WrappedComponent);
        return result;
    };
};

exports.default = geolocated;